					EXPORT	FLIGHTDEMO
					EXPORT	FLIGHTDEMO_INIT
					EXPORT	FLIGHTDEMO_ONESTEP
					EXPORT	FLIGHTDEMO_CLEANUP
					EXPORT	FLIGHTDEMO_OVER

FLIGHTDEMO_OVER		FCB		0

FLIGHTDEMO			LBSR	FLIGHTDEMO_INIT
					PSHS	A,CC
					ORCC	#$40

FLIGHTDEMO_LOOP		LBSR	FLIGHTDEMO_ONESTEP
					LDA		$FD04
					BITA	#2
					BEQ		FLIGHTDEMO_LOOP_OUT
					TST		FLIGHTDEMO_OVER,PCR
					BEQ		FLIGHTDEMO_LOOP
FLIGHTDEMO_LOOP_OUT
					LBSR	FLIGHTDEMO_CLEANUP
					PULS	A,CC,PC


; Use TRANS3D_VIEWX,VIEWY,VIEWZ,VIEWH,VIEWP,VIEWB to retain the view coordinates.
FLIGHTDEMO_PHASE	FCB		0
FLIGHTDEMO_PHASECTR	FCB		0
FLIGHTDEMO_VRAMADDR	FDB		0

FLIGHTDEMO_INIT		PSHS	A,B,X,U

					CLR		$FD38
					CLR		$FD39
					CLR		$FD3A
					CLR		$FD3B
					CLR		$FD3C
					CLR		$FD3D
					CLR		$FD3E
					CLR		$FD3F

					LBSR	INSTALL_LINEDDA_IN_SUBCPU
					LBSR	INSTALL_CLEAR_BITPLANE_IN_SUBCPU
					LBSR	CLEAR_SCREEN

					LDD		#0
					STD		TRANS3D_VIEWX,PCR
					STD		TRANS3D_VIEWZ,PCR
					LDD		#8200
					STD		TRANS3D_VIEWY,PCR

					CLR		TRANS3D_VIEWH,PCR
					CLR		TRANS3D_VIEWB,PCR
					LDA		#-64
					STA		TRANS3D_VIEWP,PCR

					CLR		FLIGHTDEMO_OVER,PCR
					CLR		FLIGHTDEMO_PHASE,PCR
					CLR		FLIGHTDEMO_PHASECTR,PCR

					PULS	A,B,X,U,PC


FLIGHTDEMO_ONESTEP	PSHS	A,B,X,U

					LDA		FLIGHTDEMO_PHASE,PCR
					; CMPA	#0
					BEQ		FLIGHTDEMO_PHASE0_ONESTEP
					CMPA	#1
					BEQ		FLIGHTDEMO_PHASE1_ONESTEP
					CMPA	#2
					BEQ		FLIGHTDEMO_PHASE2_ONESTEP
					CMPA	#3
					BEQ		FLIGHTDEMO_PHASE3_ONESTEP
					CMPA	#4
					LBEQ	FLIGHTDEMO_PHASE4_ONESTEP
					CMPA	#5
					LBEQ	FLIGHTDEMO_PHASE5_ONESTEP
					LBRA	FLIGHTDEMO_RENDER

FLIGHTDEMO_PHASE0_ONESTEP
					LDX		TRANS3D_VIEWY,PCR
					LEAX	-1000,X
					STX		TRANS3D_VIEWY,PCR
					LDA		TRANS3D_VIEWH,PCR
					ADDA	#8
					STA		TRANS3D_VIEWH,PCR
					INC		FLIGHTDEMO_PHASECTR,PCR
					LDA		FLIGHTDEMO_PHASECTR,PCR
					CMPA	#8
					LBEQ		FLIGHTDEMO_NEXTPHASE
					LBRA		FLIGHTDEMO_RENDER
FLIGHTDEMO_PHASE1_ONESTEP
					LDA		TRANS3D_VIEWP,PCR
					ADDA	#8
					STA		TRANS3D_VIEWP,PCR
					INC		FLIGHTDEMO_PHASECTR,PCR
					LDA		FLIGHTDEMO_PHASECTR,PCR
					CMPA	#8
					LBEQ		FLIGHTDEMO_NEXTPHASE
					LBRA	FLIGHTDEMO_RENDER

FLIGHTDEMO_PHASE2_ONESTEP
					LDA		TRANS3D_VIEWB,PCR
					SUBA	#6
					CMPA	#-32
					BGE		FLIGHTDEMO_PHASE2_ONESTEP_BANKED
					LDA		#-32
FLIGHTDEMO_PHASE2_ONESTEP_BANKED
					STA		TRANS3D_VIEWB,PCR
					ASRA
					ASRA
					ADDA	TRANS3D_VIEWH,PCR
					STA		TRANS3D_VIEWH,PCR
					LBSR	FLIGHTDEMO_MOVEFORWARD
					INC		FLIGHTDEMO_PHASECTR,PCR
					LDA		FLIGHTDEMO_PHASECTR,PCR
					CMPA	#32
					BEQ		FLIGHTDEMO_NEXTPHASE
					BRA		FLIGHTDEMO_RENDER

FLIGHTDEMO_PHASE3_ONESTEP
					LDA		TRANS3D_VIEWB,PCR
					ADDA	#6
					CMPA	#32
					BLE		FLIGHTDEMO_PHASE3_ONESTEP_BANKED
					LDA		#32
FLIGHTDEMO_PHASE3_ONESTEP_BANKED
					STA		TRANS3D_VIEWB,PCR
					ASRA
					ASRA
					ADDA	TRANS3D_VIEWH,PCR
					STA		TRANS3D_VIEWH,PCR
					LBSR	FLIGHTDEMO_MOVEFORWARD
					INC		FLIGHTDEMO_PHASECTR,PCR
					LDA		FLIGHTDEMO_PHASECTR,PCR
					CMPA	#32
					BEQ		FLIGHTDEMO_NEXTPHASE
					BRA		FLIGHTDEMO_RENDER

FLIGHTDEMO_PHASE4_ONESTEP
					LDA		TRANS3D_VIEWB,PCR
					SUBA	#8
					BGE		FLIGHTDEMO_PHASE4_ONESTEP_BANKED
					CLRA
FLIGHTDEMO_PHASE4_ONESTEP_BANKED
					STA		TRANS3D_VIEWB,PCR
					ASRA
					ASRA
					ADDA	TRANS3D_VIEWH,PCR
					STA		TRANS3D_VIEWH,PCR
					LBSR	FLIGHTDEMO_MOVEFORWARD
					INC		FLIGHTDEMO_PHASECTR,PCR
					LDA		FLIGHTDEMO_PHASECTR,PCR
					CMPA	#32
					BEQ		FLIGHTDEMO_NEXTPHASE
					BRA		FLIGHTDEMO_RENDER

FLIGHTDEMO_PHASE5_ONESTEP
					LBSR	FLIGHTDEMO_MOVEFORWARD
					INC		FLIGHTDEMO_PHASECTR,PCR
					LDA		FLIGHTDEMO_PHASECTR,PCR
					CMPA	#5
					BNE		FLIGHTDEMO_RENDER
					STA		FLIGHTDEMO_OVER,PCR
					BRA		FLIGHTDEMO_RENDER

FLIGHTDEMO_NEXTPHASE
					INC		FLIGHTDEMO_PHASE,PCR
					CLR		FLIGHTDEMO_PHASECTR,PCR
FLIGHTDEMO_RENDER
					LDX		#COMMON_LINEBUFPTR
					STX		GNDLATTICE_LINEBUFPTR,PCR
					STX		LINEDDA_LINEBUF_PTR,PCR

					LDX		FLIGHTDEMO_VRAMADDR,PCR	; <-VRAM Plane to Write
					STX		LINEDDA_VRAMADDR,PCR

					LDA		#80
					STA		LINEDDA_BYTE_PER_LINE,PCR
					LBSR	LINEDDA_INIT_LINEBUF

					LBSR	RENDER_GNDLATTICE


					LDU		GNDLATTICE_LINEBUFPTR,PCR
					STU		CALL_LINEDDA_SUBCPU_DATAADDR,PCR

					LBSR	CALL_CLS_AND_LINEDDA_SUBCPU

					; Turned out my FM-7 has an issue with the Blue plane.
					; Avoid it.  Use Red & Green.

					LDA		#5	; Cyan
FLIGHTDEMO_SWAPBUFFERS
					LDX		FLIGHTDEMO_VRAMADDR,PCR
					CMPX	#$8000
					BEQ		FLIGHTDEMO_SWAPBUFFERS8000
FLIGHTDEMO_SWAPBUFFERS4000
					CLR		$FD39	' 001 <- X=4000 Writing to Red. Expose Green.
					CLR		$FD3A	' 010
					CLR		$FD3B	' 011
					STA		$FD3C	' 100
					STA		$FD3D	' 101
					STA		$FD3E	' 110
					STA		$FD3F	' 111
					LDX		#$8000
					STX		FLIGHTDEMO_VRAMADDR,PCR
					BRA		FLIGHTDEMO_END
FLIGHTDEMO_SWAPBUFFERS8000
					CLR		$FD39	' 001 <- X=8000 Writing to Green. Expose Red
					STA		$FD3A	' 010
					STA		$FD3B	' 011
					CLR		$FD3C	' 100
					CLR		$FD3D	' 101
					STA		$FD3E	' 110
					STA		$FD3F	' 111
					LDX		#$4000
					STX		FLIGHTDEMO_VRAMADDR,PCR

FLIGHTDEMO_END		PULS	A,B,X,U,PC

FLIGHTDEMO_MOVEFORWARD
					LDA		TRANS3D_VIEWP,PCR
					STA		CALC_FWD_VECTOR_P,PCR
					LDA		TRANS3D_VIEWH,PCR
					STA		CALC_FWD_VECTOR_H,PCR
					LDA		TRANS3D_VIEWB,PCR
					STA		CALC_FWD_VECTOR_B,PCR
					LBSR	CALC_FWD_VECTOR

					LDD		CALC_FWD_VECTOR_X,PCR
					ASRA
					RORB
					ASRA
					RORB
					ADDD	TRANS3D_VIEWX,PCR
					STD		TRANS3D_VIEWX,PCR

					LDD		CALC_FWD_VECTOR_Y,PCR
					ASRA
					RORB
					ASRA
					RORB
					ADDD	TRANS3D_VIEWY,PCR
					STD		TRANS3D_VIEWY,PCR

					LDD		CALC_FWD_VECTOR_Z,PCR
					ASRA
					RORB
					ASRA
					RORB
					ADDD	TRANS3D_VIEWZ,PCR
					STD		TRANS3D_VIEWZ,PCR
					RTS


FLIGHTDEMO_CLEANUP	PSHS	A,B,X,U
					LBSR	CLEAR_SCREEN
					LBSR	SUBCPU_WAIT_READY
					CLRA
					LDX		#$FD38
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					STA		,X+
					INCA
					PULS	A,B,X,U,PC


